/// Errors that can be thrown while working with Multipart.
public struct MultipartError: Error {
    /// See `Debuggable`.
    public static let readableName = "Multipart Error"

    /// See `Debuggable`.
    public let identifier: String

    /// See `Debuggable`.
    public var reason: String

    /// Creates a new `MultipartError`.
    public init(identifier: String, reason: String) {
        self.identifier = identifier
        self.reason = reason
    }
}
